/*
 * %kadu copyright begin%
 * Copyright 2010, 2011 Piotr Galiszewski (piotr.galiszewski@kadu.im)
 * Copyright 2009, 2010, 2011 Rafał Przemysław Malinowski (rafal.przemyslaw.malinowski@gmail.com)
 * %kadu copyright end%
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "misc/memory.h"
#include "exports.h"

#include <QtCore/QObject>
#include <QtCore/QPointer>
#include <injeqt/injeqt.h>

class InjectedFactory;
class Talkable;
class ToolTipWidget;

class KADUAPI ToolTipManager : public QObject
{
	Q_OBJECT

public:
	Q_INVOKABLE explicit ToolTipManager(QObject *parent = nullptr);
	virtual ~ToolTipManager();

	void showToolTip(const QPoint &point, const Talkable &talkable);
	void hideToolTip();

private:
	QPointer<InjectedFactory> m_injectedFactory;

	not_owned_qptr<ToolTipWidget> m_toolTipWidget;

private slots:
	INJEQT_SET void setInjectedFactory(InjectedFactory *injectedFactory);

};
